/* Copyright 1991 Digital Equipment Corporation.               */
/* All rights reserved. See copyright notice in attached file COPYRIGHT. */
/* Last modified on Mon Aug 19 22:33:23 1991 by burrows        */
#include <stdio.h>
#include "indexserver.h"

static struct msgset *dateset1 ();
static long chop ();

struct msgset *dateset (index2, msgset, date, op, not)
struct index2 *index2;
struct msgset *msgset;
char *date;
int op;
int not;
{
        struct msgset *result = 0, *tmp;

	result = dateset1 (index2, &index2->indices[0], result, date, op);
	result = dateset1 (index2, &index2->indices[1], result, date, op);

	if (not) {
		tmp = notmsgset (msgset, result);
		freemsgset (result);
		result = tmp;
	} else
		result = into_andmsgset (result, msgset);

        return (result);
}

static long chop (index2, index, date, updown)
struct index2 *index2;
struct index *index;
char *date;
int updown;
{
	long lo, hi, mid;
	int len = strlen (date);
	register long n = index->summary.dates.ndata / sizeof (long);
	long *msgs = (long *) index->summary.dates.data;
	char *msgdate;
	int cmp;

	lo = 0;
	hi = n;
	while (lo < hi) {
		mid = (lo + hi) >> 1;
		msgdate = field (index2, msgs[mid], DATEFIELD);

		cmp = strncmp (date, msgdate, len);
		if (cmp > 0)
			lo = mid+1;
		else if (cmp < 0)
			hi = mid;
		else {
			if (updown > 0)
				lo = mid+1;
			else
				hi = mid;
		}
	}

	return (lo);
}

static struct msgset *dateset1 (index2, index, msgset, date, op)
struct index2 *index2;
struct index *index;
struct msgset *msgset;
char *date;
int op;
{
	register long i, x;
	register long n = index->summary.dates.ndata / sizeof (long);
	long *msgs = (long *) index->summary.dates.data;
	long lower, upper;
	long maxmsg;
	long *bitset;

	if (msgset == 0) {
		maxmsg = 0;
		bitset = 0;
	} else {
		maxmsg = msgset->nbitset * LONGBITS;
		bitset = msgset->bitset;
	}

	if (op < 0) {
		lower = 0;
		upper = chop (index2, index, date, -1);
	} else if (op > 0) {
		lower = chop (index2, index, date, 1);
		upper = n;
	} else {
		lower = chop (index2, index, date, -1);
		upper = chop (index2, index, date, 1);
	}

	for (i = lower; i < upper; i++) {
		x = msgs[i];
		if (x >= maxmsg) {
			msgset = extendmsgset (msgset, (int)ROUNDUP (x+200000));
			maxmsg = msgset->nbitset * LONGBITS;
			bitset = msgset->bitset;
		}
		bitset[ROUNDDOWN (x)] |= (1 << BIT (x));
	}

	return (msgset);
}
