/* Copyright 1991 Digital Equipment Corporation.               */
/* All rights reserved. See copyright notice in attached file COPYRIGHT. */
/* Last modified on Mon Feb 18 15:49:41 1991 by burrows        */
#include <stdio.h>
#include <strings.h>
#include "indexserver.h"

struct msgsetvar {
	struct msgsetvar *next;
	struct msgset *set;
	char name[1];
};

static struct msgsetvar *list = 0;
static int varcount = 0;

struct msgset *getvar (name, pfound)
register char *name;
int *pfound;
{
	register struct msgsetvar *v;

	for (v = list; v != 0; v = v->next) {
		if (strcmp (name, v->name) == 0) {
			*pfound = 1;
			return (v->set);
		}
	}
	return (0);
}


void setvar (name, set)
char *name;
struct msgset *set;
{
	register struct msgsetvar *v;

	for (v = list; v != 0; v = v->next) {
		if (strcmp (name, v->name) == 0) {
			freemsgset (v->set);
			v->set = ormsgset (set, (struct msgset *) 0);
			return;
		}
	}

	v = (struct msgsetvar *) 
	    malloc ((unsigned) (sizeof (struct msgsetvar) + strlen (name) + 1));
	
	if (v == 0) {
		perror ("setvar: malloc");
		exit (2);
	}
	
	(void) strcpy (v->name, name);
	v->set = ormsgset (set, (struct msgset *) 0);
	v->next = list;
	list = v;

	if (varcount < 100)
		varcount++;
	else {
		for (v = list; v->next->next != 0; v = v->next)
			;
		freemsgset (v->next->set);
		free ((char *) v->next);
		v->next = 0;
	}
}

void clearvars ()
{
	register struct msgsetvar *v;

	while (list != 0) {
		v = list;
		list = v->next;
		freemsgset (v->set);
		free ((char *) v);
	}
	varcount = 0;
}
